// TTML로 작성된 파일을 HTML 뷰에 뿌려주기 위해 변환
editor.ttml2html = function(str)
{
	var inHTML = false;
	var sb = new StringBuffer();

	// [HTML][/HTML] 블럭을 제외한 부분에 줄바꿈문자를 BR 태그로 바꿔준다
	while(true)
	{
		if(inHTML)
		{
			if((offsetEnd = str.indexOf("[/HTML]")) != -1)
			{
				sb.append(str.substring(0, offsetEnd));
				sb.append("<!-- Tattertools HTML Block End -->");
				str = str.substring(offsetEnd + 7, str.length);

				inHTML = false;
			}
			else
				break;
		}
		else
		{
			if((offsetStart = str.indexOf("[HTML]")) != -1)
			{
				sb.append(this.nl2br(str.substring(0, offsetStart)));
				sb.append("<!-- Tattertools HTML Block Begin -->");
				str = str.substring(offsetStart + 6, str.length);

				inHTML = true;
			}
			else
			{
				sb.append(this.nl2br(str));
				break;
			}
		}
	}

	str = sb.toString();

	var regImage = new RegExp("\\[##_(([1-3][CLR])(\\|[^|]*?)+)_##\\]", "g");

	// 이미지 치환자 처리
	while(result = regImage.exec(str))
	{
		var search = result[0];

		var longDesc = " longdesc=\"" + this.addQuot(this.htmlspecialchars(result[1])) + "\" ";

		// Avoid the bug
		longDesc = longDesc.replace("&lt;", "&amp;lt;");
		longDesc = longDesc.replace("&gt;", "&amp;gt;");

		var attributes = result[1].split("|");
		var imageType = attributes[0];

		if(this.isImageFile(attributes[1]))
		{
			var imageName = this.propertyFilePath + attributes[1];
			var imageAttr = this.parseImageSize(attributes[2], "string");			
		}
		else
		{
			var imageName = servicePath + "/image/spacer.gif";
			var imageAttr = this.fileStyle;
		}

		switch(imageType)
		{
			case "1L":
				var replace = "<img class=\"tatterImageLeft\" src=\"" + imageName + "\" " + imageAttr + longDesc + "/>";
				break;
			case "1R":
				var replace = "<img class=\"tatterImageRight\" src=\"" + imageName + "\" " + imageAttr + longDesc + "/>";
				break;
			case "1C":
				var replace = "<img class=\"tatterImageCenter\" src=\"" + imageName + "\" " + imageAttr + longDesc + "/>";
				break;
			case "2C":
				imageAttr = "width=\"200\" height=\"100\"";
				var replace = "<img class=\"tatterImageDual\" src=\"" + servicePath + "/image/spacer.gif\" " + imageAttr + longDesc + "/>";
				break;
			case "3C":
				imageAttr = "width=\"300\" height=\"100\"";
				var replace = "<img class=\"tatterImageTriple\" src=\"" + servicePath + "/image/spacer.gif\" "+ imageAttr  + longDesc + "/>";
		}

		str = str.replace(search, replace);
	}

	// iMazing 처리
	var regImazing = new RegExp("\\[##_iMazing\\|(.*?)_##\\]", "g");
	while(result = regImazing.exec(str))
	{
		var search = result[0];

		var longDesc = " longdesc=\"iMazing|" + this.addQuot(this.htmlspecialchars(result[1])) + "\" ";

		// Avoid the bug
		longDesc = longDesc.replace("&lt;", "&amp;lt;");
		longDesc = longDesc.replace("&gt;", "&amp;gt;");

		var imageAttr = this.parseImageSize(result[1], "string");
		
		var replace = "<img class=\"tatterImazing\" src=\"" + servicePath + "/image/spacer.gif\" " + imageAttr + longDesc + "/>";

		str = str.replace(search, replace);
	}

	// Gallery 처리
	var regGallery = new RegExp("\\[##_Gallery\\|(.*?)_##\\]", "g");
	while(result = regGallery.exec(str))
	{
		var search = result[0];
		
		var longDesc = " longdesc=\"Gallery|" + this.addQuot(this.htmlspecialchars(result[1])) + "\" ";

		// Avoid the bug
		longDesc = longDesc.replace("&lt;", "&amp;lt;");
		longDesc = longDesc.replace("&gt;", "&amp;gt;");

		var imageAttr = this.parseImageSize(result[1], "string");
		
		var replace = "<img class=\"tatterGallery\" src=\"" + servicePath + "/image/spacer.gif\" " + imageAttr + longDesc + "/>";

		str = str.replace(search, replace);
	}

	// Jukebox 처리
	var regJukebox = new RegExp("\\[##_Jukebox\\|(.*?)_##\\]", "g");
	while(result = regJukebox.exec(str))
	{
		var search = result[0];
		
		var longDesc = " longdesc=\"Jukebox|" + this.addQuot(this.htmlspecialchars(result[1])) + "\" ";

		// Avoid the bug
		longDesc = longDesc.replace("&lt;", "&amp;lt;");
		longDesc = longDesc.replace("&gt;", "&amp;gt;");

		var replace = "<img class=\"tatterJukebox\" src=\"" + servicePath + "/image/spacer.gif\" width=\"200\" height=\"25\"" + longDesc + "/>";

		str = str.replace(search, replace);
	}

	// 단일 이미지 치환자 처리
	var regImage = new RegExp("src=[\"']?(\\[##_ATTACH_PATH_##\\][a-z.0-9/]*)", "gi");
	while(result = regImage.exec(str))
		str = str.replace(result[0], "class=\"tatterImageFree\" longdesc=\"" + result[1] + "\" src=\"" + this.propertyFilePath.substring(0, this.propertyFilePath.length - 1) + result[1].replace("[##_ATTACH_PATH_##]", ""));

	// MORE/LESS 처리
	while(true)
	{
		var pos1 = str.indexOf("[#M_");

		if(pos1 > -1)
		{
			var pos2 = str.indexOf("_M#]", pos1);

			if(pos2 > -1)
			{
				var block = str.substring(pos1 + 4, pos2);
				
				while(true)
				{
					if(block.indexOf("[#M_") == -1)
						break;
					else
						block = block.substring(block.indexOf("[#M_") + 4, block.length);
				}
				
				var more = block.substring(0, block.indexOf("|"));
				var remain = block.substring(block.indexOf("|") + 1, block.length);
				var less = remain.substring(0, remain.indexOf("|"));
				remain = remain.substring(remain.indexOf("|"), remain.length);
				var body = remain.substring(remain.indexOf("|") + 1, remain.length);

				str = str.replace("[#M_" + block + "_M#]", '<div class="tattermoreless" more="' + more + '" less="' + less + '">' + body + '</div>');
			}
			else
				break;
		}
		else
			break;
	}

	// Music 처리(J. Parker)
	var regMusic = new RegExp("<embed[^>]*id=[\"']?musicPlayer.*?></embed>", "gi");
	while(result = regMusic.exec(str))
		str = str.replace(result[0], "<img class=\"tatterMusic\" src=\"" + servicePath + "/image/spacer.gif\"" + this.parseImageSize(result[0], "string", "css") + " longDesc=\"" + this.parseAttribute(result[0], "src") + "\"/>");

	// Flash 처리
	var regEmbed = new RegExp("<embed([^<]*?)application/x-shockwave-flash(.*?)></embed>", "gi");
	while(result = regEmbed.exec(str))
		str = str.replace(result[0], "<img class=\"tatterFlash\" src=\"" + servicePath + "/image/spacer.gif\"" + this.parseImageSize(result[0], "string", "css") + " longDesc=\"" + this.parseAttribute(result[0], "src") + "\"/>");

	// Embed 처리
	var regEmbed = new RegExp("<embed([^<]*?)></embed>", "gi");
	while(result = regEmbed.exec(str))
		str = str.replace(result[0], "<img class=\"tatterEmbed\" src=\"" + servicePath + "/image/spacer.gif\"" + this.parseImageSize(result[0], "string", "css") + " longDesc=\"" + this.parseAttribute(result[0], "src") + "\"/>");

	return str;
}

// IFRAME에 작성된 HTML을 태터툴즈 텍스트 에디터에서 볼 수 있는 TTML로 전환
editor.html2ttml = function()
{
	var obj = this.contentDocument.body.cloneNode(true);

	// MORE/LESS 처리
	while(true)
	{
		var divs = obj.getElementsByTagName("div");
		
		if(divs.length > 0)
		{
			var exist = false;
			
			for(var i=0; i<divs.length; i++)
			{
				if(divs[i].className == "tattermoreless")
				{
					exist = true;
					divs[i].className = "removeme";
					divs[i].innerHTML = "[#M_" + divs[i].getAttribute("more") + "|" + divs[i].getAttribute("less") + "|" + divs[i].innerHTML + "_M#]";
				}

				if(exist)
					break;
			}
			
			if(!exist)
				break;
		}
		else
			break;
	}

	var str = obj.innerHTML;

	// 소스를 한줄로
	str = str.replace(new RegExp("\r|\n|&#10;|&#13;", "g"), "");

	// 빈줄을 br 태그로
	str = str.replace(new RegExp("<p([^>]*)>&nbsp;</p>", "gi"), "<br/>");

	// 쓸모없는 &nbsp; 제거
	str = str.replace(new RegExp("([^ ])&nbsp;([^ ])", "gi"), "$1 $2");

	var inHTML = false;
	var sb = new StringBuffer();

	// <!-- Tattertools HTML Block Begin --><!-- Tattertools HTML Block End --> 블럭을 제외한 부분에 줄바꿈문자를 BR 태그로 바꿔준다
	while(true)
	{
		if(inHTML)
		{
			if((offsetEnd = str.indexOf("<!-- Tattertools HTML Block End -->")) != -1)
			{
				sb.append(str.substring(0, offsetEnd));
				sb.append("[/HTML]");
				str = str.substring(offsetEnd + 35, str.length);

				inHTML = false;
			}
			else
				break;
		}
		else
		{
			if((offsetStart = str.indexOf("<!-- Tattertools HTML Block Begin -->")) != -1)
			{
				sb.append(str.substring(0, offsetStart).replace(new RegExp("[\r\n]*<br[ /]*>[\r\n]*", "gi"), "\r\n"));
				sb.append("[HTML]");
				str = str.substring(offsetStart + 37, str.length);

				inHTML = true;
			}
			else if(str.indexOf("<!-- Tattertools HTML Block End -->") != -1)
			{
				// IE의 경우 주석이 제일 처음에 나오면 사라지는 버그 있음
				// 시작은 없지만 끝이 있는 경우엔 시작위치를 0으로 간주
				sb.append("[HTML]");

				inHTML = true;
			}
			else
			{
				sb.append(str.replace(new RegExp("[\r\n]*<br[ /]*>[\r\n]*", "gi"), "\r\n"));
				break;
			}
		}
	}

	str = sb.toString();

	// 이미지 치환자 처리
	while(true)
	{
		var regImage = new RegExp("<img[^>]*class=[\"']?tatterImage[^>]*>", "gi");

		if(result = regImage.exec(str))
		{
			var body = result[0];

			var replace = this.parseAttribute(result[0], "longdesc");

			if(replace && replace.indexOf("[##_ATTACH_PATH_##]") == -1)
				str = str.replace(body, "[##_" + this.removeQuot(replace).replace(new RegExp("&amp;?", "gi"), "&") + "_##]");
			else
				str = str.replace(body, "<img src=\"" + replace + "\"" + this.parseImageSize(body, "string") + "/>");
		}
		else
			break;
	}

	// iMazing 처리
	while(true)
	{
		var regImaging = new RegExp("<img[^>]*class=[\"']?tatterImazing[^>]*>", "gi");

		if(result = regImaging.exec(str))
		{
			var body = result[0];

			var size = this.parseImageSize(body, "array");

			var longdesc = this.parseAttribute(result[0], "longdesc");
			longdesc = this.removeQuot(longdesc);
			longdesc = longdesc.replace(new RegExp("(width=[\"']?)\\d*", "i"), "$1" + size[0]);
			longdesc = longdesc.replace(new RegExp("(height=[\"']?)\\d*", "i"), "$1" + size[1]);

			str = str.replace(body, "[##_" + longdesc.replace(new RegExp("&amp;?", "gi"), "&") + "_##]");
		}
		else
			break;
	}

	// Gallery 처리
	while(true)
	{
		var regGallery = new RegExp("<img[^>]*class=[\"']?tatterGallery[^>]*>", "gi");

		if(result = regGallery.exec(str))
		{
			var body = result[0];
			
			var size = this.parseImageSize(body, "array");

			var longdesc = this.parseAttribute(result[0], "longdesc");
			longdesc = this.removeQuot(longdesc);
			longdesc = longdesc.replace(new RegExp("(width=[\"']?)\\d*", "i"), "$1" + size[0]);
			longdesc = longdesc.replace(new RegExp("(height=[\"']?)\\d*", "i"), "$1" + size[1]);
			longdesc = longdesc.split("|");

			// TT 1.0 alpha ~ 1.0.1까지 쓰던 Gallery 치환자를 위한 코드
			if(longdesc.length % 2 == 1)
				longdesc.length--;
	
			var files = "";

			for(var i=1; i<longdesc.length-1; i++)
				files += longdesc[i].replace(new RegExp("&amp;?", "gi"), "&") + "|";

			str = str.replace(body, "[##_Gallery|" + files + this.unHtmlspecialchars(trim(longdesc[longdesc.length-1])) + "_##]");
		}
		else
			break;
	}

	// Jukebox 처리
	while(true)
	{
		var regJukebox = new RegExp("<img[^>]*class=[\"']?tatterJukebox[^>]*>", "gi");

		if(result = regJukebox.exec(str))
		{
			var body = result[0];
			
			var size = this.parseImageSize(body, "array");

			var longdesc = this.parseAttribute(result[0], "longdesc");
			longdesc = this.removeQuot(longdesc);
			longdesc = longdesc.replace(new RegExp("(width=[\"']?)\\d*", "i"), "$1" + size[0]);
			longdesc = longdesc.replace(new RegExp("(height=[\"']?)\\d*", "i"), "$1" + size[1]);
			
			longdesc = longdesc.split("|");

			var files = "";

			for(var i=1; i<longdesc.length-2; i++)
				files += longdesc[i].replace(new RegExp("&amp;?", "gi"), "&") + "|";

			str = str.replace(body, "[##_Jukebox|" + files + this.unHtmlspecialchars(trim(longdesc[longdesc.length-2])) + "|_##]");
		}
		else
			break;
	}

	// MORE/LESS 처리 후 남은 태그 제거
	str = str.replace(new RegExp("<div.*?class=[\"']?removeme.*?\\[#M_", "gi"), "[#M_");
	str = str.replace(new RegExp("_M#\\]</div>", "gi"), "_M#]");

	// Music 처리(J. Parker)
	while(true)
	{
		var regMusic = new RegExp("<img[^>]*class=[\"']?tatterMusic.*?>", "gi");
		if(result = regMusic.exec(str))
		{
			var body = result[0];
			var longdesc = this.parseAttribute(body, "longDesc")
			longdesc = longdesc.replace(new RegExp("&amp;?", "gi"), "&");
			str = str.replace(body, "<embed id=\"musicPlayer\" Menu=\"false\" quality=\"high\" WMode=\"transparent\"" + this.parseImageSize(body, "string", "css") + "src=\"" + longdesc + "\"></embed>");
		}
		break;
	}
	
	// Embed 처리
	while(true)
	{
		var regEmbed = new RegExp("<img[^>]*class=[\"']?tatterEmbed.*?>", "gi");

		if(result = regEmbed.exec(str))
		{
			var body = result[0];

			str = str.replace(body, "<embed autostart=\"0\" src=\"" + this.parseAttribute(body, "longdesc") + "\"" + this.parseImageSize(body, "string", "css") + "></embed>");
		}

		break;
	}

	// Flash 처리
	while(true)
	{
		var regFlash = new RegExp("<img[^>]*class=[\"']?tatterFlash.*?>", "gi");

		if(result = regFlash.exec(str))
		{
			var body = result[0];

			str = str.replace(body, '<embed loop="true" menu="false" quality="high" ' + this.parseImageSize(body, "string") + ' type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash" src="' + this.parseAttribute(body, "longdesc") + '"></embed>');
		}

		break;
	}

	if(!this.isSafari)
	{
		// XHTML 1.0 정규화

		// <b> -> <strong>, <i> -> <em>, <u> -> <ins>, <strike> -> <del>
		str = str.replace(new RegExp("<b([^>]*)>(.*?)</b>", "gi"), "<strong$1>$2</strong>");
		str = str.replace(new RegExp("<i([^>]*)>(.*?)</i>", "gi"), "<em$1>$2</em>");
		str = str.replace(new RegExp("<u([^>]*)>(.*?)</u>", "gi"), "<ins$1>$2</ins>");
		str = str.replace(new RegExp("<strike([^>]*)>(.*?)</strike>", "gi"), "<del$1>$2</del>");

		var regTag = new RegExp("<([^\\s>]+)\\s*([^>]*)(/?)>", "gi");

		while(result = regTag.exec(str))
		{
			var tagBody = result[0];
			var tagStart = "<" + result[1];
			var tagFinish = result[3] + ">";

			if(tagStart == "<!--")
				continue;

			var attributeString = result[2];

			var regAttribute = new RegExp("(\\s*[^=]*)=((?:\"[^\"]+\")|(?:'[^']+')|(?:[^\\s]+))", "g");

			var attributes = new Array();

			while(result = regAttribute.exec(attributeString))
				attributes.push(new Array(result[1].trim(), result[2].replace(new RegExp("['\"](.*)['\"]", "g"), "$1").trim()));

			var sb = new StringBuffer();
			
			for(var i in attributes)
			{
				if(trim(attributes[i][0].toLowerCase()) == "style")
				{
					var regStyle = new RegExp("([\\w-]+): ([^;]*)", "gi");
					var sbStyle = new StringBuffer();

					while(result = regStyle.exec(attributes[i][1]))
						sbStyle.append(result[1].toLowerCase() + ": " + result[2] + "; ");
 
					sb.append(" style=\"" + sbStyle.toString().replace(new RegExp("(.*); $", "g"), "$1") + "\"");
				}
				else
					sb.append(" " + attributes[i][0].toLowerCase() + "=\"" + attributes[i][1] + "\"");
			}

			var tagAttributes = sb.toString();

			switch(tagStart.toLowerCase())
			{
				case "<img":
				case "<br":
				case "<hr":
					tagFinish = (tagFinish == ">") ? "/>" : tagFinish;
			}

			if(tagStart.toLowerCase() == "<img" && tagAttributes.indexOf("alt=") == -1)
				tagFinish = " alt=\"\"" + tagFinish;

			str = str.replace(tagBody, tagStart.toLowerCase() + tagAttributes + tagFinish);
		}
	}

	return str;
}

// 위지윅 모드에서 치환자 이미지를 클릭했을때 편집창 옆에 속성창을 보여준다
editor.showProperty = function(obj)
{
	var attribute = editor.isSafari ? obj.longdesc : obj.getAttribute("longdesc");

	document.getElementById("propertyImage1").style.display = "none";
	document.getElementById("propertyImage2").style.display = "none";
	document.getElementById("propertyImage3").style.display = "none";
	document.getElementById("propertyObject1").style.display = "none";
	document.getElementById("propertyObject2").style.display = "none";
	document.getElementById("propertyObject3").style.display = "none";
	document.getElementById("propertyiMazing").style.display = "none";
	document.getElementById("propertyiMazing_preview").style.display = "none";
	document.getElementById("propertyGallery").style.display = "none";
	document.getElementById("propertyGallery_preview").style.display = "none";
	document.getElementById("propertyJukebox").style.display = "none";
	document.getElementById("propertyEmbed").style.display = "none";
	document.getElementById("propertyFlash").style.display = "none";
	document.getElementById("propertyMoreLess").style.display = "none";	

	if(obj.className == "tatterMusic") return false;

	if(obj.className == "tatterEmbed") {
		editor.propertyHeader = "tatterEmbed";
		editor.propertyWindowId = "propertyEmbed";
		var size = editor.parseImageSize(editor.selectedElement, "array");
		document.getElementById("propertyEmbed_width").value = size[0];
		document.getElementById("propertyEmbed_height").value = size[1];
		document.getElementById("propertyEmbed_src").value = attribute;
		document.getElementById("propertyEmbed").style.display = "block";
	}
	else if(obj.className == "tatterFlash") {
		editor.propertyHeader = "tatterFlash";
		editor.propertyWindowId = "propertyFlash";
		var size = editor.parseImageSize(editor.selectedElement, "array");
		document.getElementById("propertyFlash_width").value = size[0];
		document.getElementById("propertyFlash_height").value = size[1];
		document.getElementById("propertyFlash_src").value = attribute;
		document.getElementById("propertyFlash").style.display = "block";
	}
	else if(obj.tagName && obj.tagName.toLowerCase() == "img" && attribute)
	{
		var values = attribute.split("|");

		editor.propertyHeader = values[0];

		if(values[0] == "iMazing" || values[0] == "Gallery" || values[0] == "Jukebox")
		{
			var objectCount = 1;
			var objectType = values[0];
			var propertyWindowId= "property" + objectType;
		}
		else
		{
			var objectCount = values[0].charAt(0);
			var objectType = editor.isImageFile(values[1]) ? "Image" : "Object";
			var propertyWindowId = "property" + objectType + objectCount;
		}

		editor.propertyWindowId = propertyWindowId;

		if(objectType == "Image")
		{
			document.getElementById(propertyWindowId + "_width1").value = trim(editor.removeQuot(editor.parseAttribute(values[2], "width")));
			document.getElementById(propertyWindowId + "_alt1").value = trim(editor.unHtmlspecialchars(editor.removeQuot(editor.parseAttribute(values[2], "alt"))));
			document.getElementById(propertyWindowId + "_caption1").value = trim(editor.unHtmlspecialchars(editor.removeQuot(values[3])));

			editor.propertyFilename1 = values[1];

			if(objectCount == 1)
			{
				var size = editor.parseImageSize(editor.selectedElement, "array");

				if(editor.propertyCurrentImage == editor.selectedElement.getAttribute("src"))
				{
					var newWidth = size[0];
					var newHeight = parseInt(size[0] * editor.propertyCurrentProportion1);					
					editor.propertyCurrentProportion1 = newHeight / newWidth;
					editor.selectedElement.removeAttribute("width");
					editor.selectedElement.removeAttribute("height");
					editor.selectedElement.style.width = newWidth + "px";
					editor.selectedElement.style.height = newHeight + "px";
				}
				else
				{
					editor.propertyCurrentProportion1 = size[1] / size[0];
					editor.propertyCurrentImage = editor.selectedElement.getAttribute("src");
				}
			}
			else
			{				
				var size = editor.parseImageSize(values[2], "array");
				editor.propertyCurrentProportion1 = size[1] / size[0];
				if(objectCount > 1)
				{
					var size = editor.parseImageSize(values[5], "array");
					editor.propertyCurrentProportion2 = size[1] / size[0];
				}
				if(objectCount > 2)
				{
					var size = editor.parseImageSize(values[8], "array");
					editor.propertyCurrentProportion3 = size[1] / size[0];
				}
			}

			if(objectCount > 1)
			{				
				document.getElementById(propertyWindowId + "_width2").value = trim(editor.removeQuot(editor.parseAttribute(values[5], "width")));
				document.getElementById(propertyWindowId + "_alt2").value = trim(editor.unHtmlspecialchars(editor.removeQuot(editor.parseAttribute(values[5], "alt"))));
				document.getElementById(propertyWindowId + "_caption2").value = trim(editor.unHtmlspecialchars(editor.removeQuot(values[6])));
			}

			editor.propertyFilename2 = values[4];

			if(objectCount > 2)
			{
				document.getElementById(propertyWindowId + "_width3").value = trim(editor.removeQuot(editor.parseAttribute(values[8], "width")));
				document.getElementById(propertyWindowId + "_alt3").value = trim(editor.unHtmlspecialchars(editor.removeQuot(editor.parseAttribute(values[8], "alt"))));
				document.getElementById(propertyWindowId + "_caption3").value = trim(editor.unHtmlspecialchars(editor.removeQuot(values[9])));
			}
			
			editor.propertyFilename3 = values[7];
		}
		else if(objectType == "Object")
		{
			document.getElementById(propertyWindowId + "_caption1").value = trim(editor.unHtmlspecialchars(editor.removeQuot(values[3])));
			document.getElementById(propertyWindowId + "_filename1").innerHTML = editor.getFilenameFromFilelist(values[1]);
			editor.propertyFilename1 = values[1];
			
			if(objectCount > 1)
			{
				document.getElementById(propertyWindowId + "_caption2").value = trim(editor.unHtmlspecialchars(editor.removeQuot(values[6])));
				document.getElementById(propertyWindowId + "_filename2").innerHTML = editor.getFilenameFromFilelist(values[4]);
				editor.propertyFilename2 = values[4];
			}

			if(objectCount > 2)
			{
				document.getElementById(propertyWindowId + "_caption3").value = trim(editor.unHtmlspecialchars(editor.removeQuot(values[9])));
				document.getElementById(propertyWindowId + "_filename3").innerHTML = editor.getFilenameFromFilelist(values[7]);
				editor.propertyFilename3 = values[7];
			}
		}
		else if(objectType == "iMazing")
		{
			var size = editor.parseImageSize(editor.selectedElement, "array");
			var attributes = values[values.length-2];
			
			document.getElementById(propertyWindowId + "_width").value = size[0];
			document.getElementById(propertyWindowId + "_height").value = size[1];
			document.getElementById(propertyWindowId + "_frame").value = editor.parseAttribute(attributes, "frame");
			document.getElementById(propertyWindowId + "_tran").value = editor.parseAttribute(attributes, "transition");
			document.getElementById(propertyWindowId + "_nav").value = editor.parseAttribute(attributes, "navigation");
			document.getElementById(propertyWindowId + "_sshow").value = editor.parseAttribute(attributes, "slideshowInterval");
			document.getElementById(propertyWindowId + "_page").value = editor.parseAttribute(attributes, "page");
			document.getElementById(propertyWindowId + "_align").value = editor.parseAttribute(attributes, "align");
			document.getElementById(propertyWindowId + "_caption").value = trim(editor.unHtmlspecialchars(editor.removeQuot(values[values.length-1])));
			
			var list = document.getElementById(propertyWindowId + "_list");

			list.innerHTML = "";

			for(var i=1; i<values.length-2; i+=2)
				list.options[list.length] = new Option(editor.getFilenameFromFilelist(values[i]), values[i] + "|", false, false);
		}
		else if(objectType == "Gallery")
		{
			var size = editor.parseImageSize(editor.selectedElement, "array");
			var attributes = values[values.length-2];
			
			document.getElementById(propertyWindowId + "_width").value = size[0];
			document.getElementById(propertyWindowId + "_height").value = size[1];
			document.getElementById(propertyWindowId + "_caption").value = "";

			var list = document.getElementById(propertyWindowId + "_list");

			list.innerHTML = "";

			for(var i=1; i<values.length-2; i+=2)
				list.options[list.length] = new Option(editor.getFilenameFromFilelist(values[i]), values[i] + "|" + editor.unHtmlspecialchars(values[i+1]), false, false);
		}
		else if(objectType == "Jukebox")
		{	
			document.getElementById(propertyWindowId + "_autoplay").checked = editor.parseAttribute(values[values.length-2], "autoplay") == 1;
			document.getElementById(propertyWindowId + "_visibility").checked = editor.parseAttribute(values[values.length-2], "visible") == 1;

			var list = document.getElementById(propertyWindowId + "_list");

			list.innerHTML = ""; 

			for(var i=1; i<values.length-2; i+=2)
				list.options[list.length] = new Option(editor.getFilenameFromFilelist(values[i]), values[i] + "|" + editor.unHtmlspecialchars(values[i+1]), false, false);
		}

		document.getElementById(propertyWindowId).style.display = "block";
	}
	else
	{
		var node = obj;
		
		while(node.parentNode)
		{
			if(node.tagName && node.tagName.toLowerCase() == "div" && node.getAttribute("more") != null && node.getAttribute("less") != null)
			{
				var moreText = editor.isSafari ? node.more : node.getAttribute("more");
				var lessText = editor.isSafari ? node.less : node.getAttribute("less");
				
				document.getElementById("propertyMoreLess_more").value = trim(editor.unHtmlspecialchars(moreText));
				document.getElementById("propertyMoreLess_less").value = trim(editor.unHtmlspecialchars(lessText));
				
				document.getElementById("propertyMoreLess").style.display = "block";
				
				editor.propertyWindowId = "propertyMoreLess";

				return;
			}

			node = node.parentNode;
		}
	}
}